
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Aqua
#property indicator_width1 0
#property indicator_width2 0
extern int dist2 = 21;
extern int dist1 = 14;
extern int arrowDistance = 15;
extern bool alertsOn = TRUE;
extern string note1 = "alert all = 0";
extern string note2 = "buy only = 1, sell only = 2";
extern string note3 = "strong buy or strong sell = 3";
extern int alertsOption = 0;
extern bool alertsOnCurrent = TRUE;
extern bool alertsMessage = False;
extern bool alertsSound = False;
extern bool alertsEmail = True;
double g_ibuf_136[];
double g_ibuf_140[];
double g_ibuf_144[];
double g_ibuf_148[];
string gs_nothing_152 = "nothing";
datetime g_time_160;

int init() {
   SetIndexBuffer(0, g_ibuf_136);
   SetIndexBuffer(1, g_ibuf_140);
   SetIndexBuffer(2, g_ibuf_144);
   SetIndexBuffer(3, g_ibuf_148);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 334);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 333);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexArrow(1, 233);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexArrow(0, 234);
   return (0);
}

int start() {
   int l_highest_12;
   int l_lowest_16;
   int l_highest_20;
   int l_lowest_24;
   double ld_32;
   int li_40;
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_8 = Bars - li_0;
   li_8 = MathMax(li_8, dist1);
   li_8 = MathMax(li_8, dist2);
   int li_28 = 1;
   if (Digits == 3 || Digits == 5) li_28 = 10;
   for (int li_4 = li_8; li_4 >= 0; li_4--) {
      l_highest_20 = iHighest(NULL, 0, MODE_HIGH, dist1, li_4 - dist1 / 2);
      l_lowest_24 = iLowest(NULL, 0, MODE_LOW, dist1, li_4 - dist1 / 2);
      l_highest_12 = iHighest(NULL, 0, MODE_HIGH, dist2, li_4 - dist2 / 2);
      l_lowest_16 = iLowest(NULL, 0, MODE_LOW, dist2, li_4 - dist2 / 2);
      g_ibuf_136[li_4] = EMPTY_VALUE;
      g_ibuf_140[li_4] = EMPTY_VALUE;
      g_ibuf_144[li_4] = EMPTY_VALUE;
      g_ibuf_148[li_4] = EMPTY_VALUE;
      ld_32 = Point * li_28 * arrowDistance;
      if (li_4 == l_highest_12) g_ibuf_136[li_4] = High[l_highest_12] + ld_32;
      if (li_4 == l_lowest_16) g_ibuf_140[li_4] = Low[l_lowest_16] - ld_32;
      if (li_4 == l_highest_20) g_ibuf_144[li_4] = High[l_highest_20] + ld_32 / 2.0;
      if (li_4 == l_lowest_24) g_ibuf_148[li_4] = Low[l_lowest_24] - ld_32 / 2.0;
   }
   if (alertsOn) {
      li_40 = 1;
      if (alertsOnCurrent) li_40 = 0;
      if (alertsOption == 0) {
         if (g_ibuf_136[li_40] != EMPTY_VALUE && g_ibuf_144[li_40] != EMPTY_VALUE) doAlert("Strong Sell if the histogram indicator turns red");
         if (g_ibuf_136[li_40] != EMPTY_VALUE && g_ibuf_144[li_40] == EMPTY_VALUE) doAlert("sell");
         if (g_ibuf_136[li_40] == EMPTY_VALUE && g_ibuf_144[li_40] != EMPTY_VALUE) doAlert("minor sell or exit buy");
         if (g_ibuf_140[li_40] != EMPTY_VALUE && g_ibuf_148[li_40] != EMPTY_VALUE) doAlert("Strong Buy if the histogram indicator turns yellow");
         if (g_ibuf_140[li_40] != EMPTY_VALUE && g_ibuf_148[li_40] == EMPTY_VALUE) doAlert("buy");
         if (g_ibuf_140[li_40] == EMPTY_VALUE && g_ibuf_148[li_40] != EMPTY_VALUE) doAlert("minor buy or exit sell");
      }
      if (alertsOption == 1) {
         if (g_ibuf_140[li_40] != EMPTY_VALUE && g_ibuf_148[li_40] != EMPTY_VALUE) doAlert("Strong Buy if the histogram indicator turns yellow");
         if (g_ibuf_140[li_40] != EMPTY_VALUE && g_ibuf_148[li_40] == EMPTY_VALUE) doAlert("buy");
         if (g_ibuf_140[li_40] == EMPTY_VALUE && g_ibuf_148[li_40] != EMPTY_VALUE) doAlert("minor buy or exit sell");
      }
      if (alertsOption == 2) {
         if (g_ibuf_136[li_40] != EMPTY_VALUE && g_ibuf_144[li_40] != EMPTY_VALUE) doAlert("Strong Sell if the histogram indicator turns red");
         if (g_ibuf_136[li_40] != EMPTY_VALUE && g_ibuf_144[li_40] == EMPTY_VALUE) doAlert("sell");
         if (g_ibuf_136[li_40] == EMPTY_VALUE && g_ibuf_144[li_40] != EMPTY_VALUE) doAlert("minor sell or exit buy");
      }
      if (alertsOption == 3) {
         if (g_ibuf_140[li_40] != EMPTY_VALUE && g_ibuf_148[li_40] != EMPTY_VALUE) doAlert("Strong Buy if the histogram indicator turns yellow");
         if (g_ibuf_136[li_40] != EMPTY_VALUE && g_ibuf_144[li_40] != EMPTY_VALUE) doAlert("Strong Sell if the histogram indicator turns red");
      }
   }
   return (0);
}

void doAlert(string as_0) {
   string l_str_concat_8;
   string ls_16;
   if (Period() == PERIOD_M1) ls_16 = "1 MIN";
   if (Period() == PERIOD_M5) ls_16 = "5 MIN";
   if (Period() == PERIOD_M15) ls_16 = "15 MIN";
   if (Period() == PERIOD_M30) ls_16 = "30 MIN";
   if (Period() == PERIOD_H1) ls_16 = "1 HR";
   if (Period() == PERIOD_H4) ls_16 = "4 HR";
   if (Period() == PERIOD_D1) ls_16 = "DAILY";
   if (Period() == PERIOD_W1) ls_16 = "WEEKLY";
   if (Period() == PERIOD_MN1) ls_16 = "MONTHLY";
   if (gs_nothing_152 != as_0 || g_time_160 != Time[0]) {
      gs_nothing_152 = as_0;
      g_time_160 = Time[0];
      l_str_concat_8 = StringConcatenate(Symbol(), " at ", ls_16, " Arrow Indicator : ", as_0);
      if (alertsMessage) Alert(l_str_concat_8);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), " Arrow Indicator "), l_str_concat_8);
      if (alertsSound) PlaySound("alert2.wav");
   }
}